spandsp 0.0.6

v27ter_tx.h File Reference

Go to the source code of this file.

## Typedefs
typedef struct v27ter_tx_state_s | v27ter_tx_state_t

## Functions
void | v27ter_tx_power (v27ter_tx_state_t *s, float power)
| Adjust a V.27ter modem transmit context's output power.
v27ter_tx_state_t * | v27ter_tx_init (v27ter_tx_state_t *s, int bit_rate, int tep, get_bit_func_t get_bit, void *user_data)
| Initialise a V.27ter modem transmit context.
int | v27ter_tx_restart (v27ter_tx_state_t *s, int bit_rate, int tep)
| Reinitialise an existing V.27ter modem transmit context.
int | v27ter_tx_release (v27ter_tx_state_t *s)
| Release a V.27ter modem transmit context.
int | v27ter_tx_free (v27ter_tx_state_t *s)
| Free a V.27ter modem transmit context.
logging_state_t * | v27ter_tx_get_logging_state (v27ter_tx_state_t *s)
| Get the logging context associated with a V.27ter modem transmit context.
void | v27ter_tx_set_get_bit (v27ter_tx_state_t *s, get_bit_func_t get_bit, void *user_data)
| Change the get_bit function associated with a V.27ter modem transmit context.
void | v27ter_tx_set_modem_status_handler (v27ter_tx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.27ter modem transmit context.
| SPAN_DECLARE_NONSTD (int) v27ter_tx(v27ter_tx_state_t *s
| Generate a block of V.27ter modem audio samples.

## Variables
int16_t | amp []
int16_t int | len

## Typedef Documentation

## ◆ v27ter_tx_state_t

typedef struct v27ter_tx_state_s v27ter_tx_state_t

V.27ter modem transmit side descriptor. This defines the working state for a single instance of a V.27ter modem transmitter.

## Function Documentation

## ◆ SPAN_DECLARE_NONSTD()

SPAN_DECLARE_NONSTD | ( | int |  | ) |

Generate a block of V.27ter modem audio samples.

Get the next bit of data from a T.38 rate adapting non-ECM buffer context.

Get a bit of received non-ECM image data.

Get the next bit of a transmitted serial bit stream.

Generate a block of V.27ter modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples to be generated.

Returns
  The number of samples actually generated.

## ◆ v27ter_tx_free()

int v27ter_tx_free | ( | v27ter_tx_state_t * | s | ) |

Free a V.27ter modem transmit context.

Free a V.27ter modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v27ter_tx_get_logging_state()

logging_state_t * v27ter_tx_get_logging_state | ( | v27ter_tx_state_t * | s | ) |

Get the logging context associated with a V.27ter modem transmit context.

Get the logging context associated with a V.27ter modem transmit context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v27ter_tx_state_s::logging.

## ◆ v27ter_tx_init()

v27ter_tx_state_t * v27ter_tx_init | ( | v27ter_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Initialise a V.27ter modem transmit context.

Initialise a V.27ter modem transmit context.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 2400 and 4800.
  tep | TRUE is the optional TEP tone is to be transmitted.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References CARRIER_NOMINAL_FREQ, v27ter_tx_state_s::carrier_phase_rate, dds_phase_ratef(), v27ter_tx_state_s::get_bit, v27ter_tx_state_s::get_bit_user_data, v27ter_tx_state_s::logging, v27ter_tx_power(), and v27ter_tx_restart().

## ◆ v27ter_tx_power()

void v27ter_tx_power | ( | v27ter_tx_state_t * | s,
|  | float | power )

Adjust a V.27ter modem transmit context's output power.

Adjust a V.27ter modem transmit context's power output.

Parameters

  s | The modem context.
  power | The power level, in dBm0

References v27ter_tx_state_s::gain_2400, and v27ter_tx_state_s::gain_4800.

Referenced by v27ter_tx_init().

## ◆ v27ter_tx_release()

int v27ter_tx_release | ( | v27ter_tx_state_t * | s | ) |

Release a V.27ter modem transmit context.

Release a V.27ter modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v27ter_tx_restart()

int v27ter_tx_restart | ( | v27ter_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep )

Reinitialise an existing V.27ter modem transmit context.

Reinitialise an existing V.27ter modem transmit context, so it may be reused.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 2400 and 4800.
  tep | TRUE is the optional TEP tone is to be transmitted.

Returns
  0 for OK, -1 for bad parameter

References v27ter_tx_state_s::baud_phase, v27ter_tx_state_s::bit_rate, v27ter_tx_state_s::carrier_phase, v27ter_tx_state_s::constellation_state, v27ter_tx_state_s::current_get_bit, v27ter_tx_state_s::in_training, v27ter_tx_state_s::rrc_filter, v27ter_tx_state_s::rrc_filter_step, v27ter_tx_state_s::scramble_reg, v27ter_tx_state_s::scrambler_pattern_count, v27ter_tx_state_s::training_step, V27TER_TRAINING_SEG_1, and V27TER_TRAINING_SEG_2.

Referenced by v27ter_tx_init().

## ◆ v27ter_tx_set_get_bit()

void v27ter_tx_set_get_bit | ( | v27ter_tx_state_t * | s,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Change the get_bit function associated with a V.27ter modem transmit context.

Change the get_bit function associated with a V.27ter modem transmit context.

Parameters

  s | The modem context.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

References v27ter_tx_state_s::current_get_bit, v27ter_tx_state_s::get_bit, and v27ter_tx_state_s::get_bit_user_data.

## ◆ v27ter_tx_set_modem_status_handler()

void v27ter_tx_set_modem_status_handler | ( | v27ter_tx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.27ter modem transmit context.

Change the modem status report function associated with a V.27ter modem transmit context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v27ter_tx_state_s::status_handler, and v27ter_tx_state_s::status_user_data.